%global flavor gcc32winthr

%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}
%define __debug_install_post %{_mingw32_debug_install_post}

%global oname globus-common
%global _name %(tr - _ <<< %{oname})

Name:		mingw32-%{oname}
Version:	11.6
%global setupversion 2.6
Release:	1%{?dist}
Summary:	Globus Toolkit for MinGW - Common Library

Group:		Development/Libraries
License:	ASL 2.0
URL:		http://www.globus.org/
#		Source is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt5/5.0/5.0.3/installers/src/gt5.0.3-all-source-installer.tar.bz2
#		tar -jxf gt5.0.3-all-source-installer.tar.bz2
#		mv gt5.0.3-all-source-installer/source-trees/common/source globus_common-11.6
#		cp -p gt5.0.3-all-source-installer/source-trees/core/source/GLOBUS_LICENSE globus_common-11.6
#		tar -zcf globus_common-11.6.tar.gz globus_common-11.6
Source:		%{_name}-%{version}.tar.gz
#		Source1 is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt5/5.0/5.0.3/installers/src/gt5.0.3-all-source-installer.tar.bz2
#		tar -jxf gt5.0.3-all-source-installer.tar.bz2
#		mv gt5.0.3-all-source-installer/source-trees/common/setup globus_common_setup-2.6
#		cp -p gt5.0.3-all-source-installer/source-trees/core/source/GLOBUS_LICENSE globus_common_setup-2.6
#		tar -zcf globus_common_setup-2.6.tar.gz globus_common_setup-2.6
Source1:	%{_name}_setup-%{setupversion}.tar.gz
#		Environment variable elimination patch:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6459
Patch0:		%{oname}-usr.patch
#		Segfault fix patch:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6460
Patch1:		%{oname}-no-pthread-exceptions.patch
#		Allow plugins without the flavor extension in the name:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6461
Patch2:		%{oname}-noflavext.patch
#		Remove bogus inter-package dependency:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6462
Patch3:		%{oname}-deps.patch
#		Fixes a stupid typo in library/Makefile.am:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6463
Patch4:		%{oname}-typo.patch
#		The file globus_netos_dir.h does not exist:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6464
Patch5:		%{oname}-nosuchfile.patch
#		Doxygen warning fix:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6465
Patch6:		%{oname}-doxygen.patch
#		Extradist should not be conditional:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6576
Patch7:		%{oname}-extradist.patch
#		Check for function removed from newer versions of libltdl:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6578
Patch8:		%{oname}-ltdlmutex.patch
#		Fixes for mingw compilation:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6742
Patch9:		%{oname}-mingw.patch
#		Not all platforms defines PATH_MAX:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6755
Patch10:	%{oname}-pathmax.patch
#		Let globus-makefile-header fail gracefully without GPT:
#		Not really relevant for globus upstream
Patch11:	%{oname}-makefile-header.patch
#		Workaround a bug in doxygen 1.6.0 and later:
#		https://bugzilla.gnome.org/show_bug.cgi?id=593759
Patch12:	%{oname}-doxygen-workaround.patch
#		Configure options not propagated in globus common setup:
#		http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=6467
Patch13:	%{oname}-setup.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Provides:	%{name}-setup = %{setupversion}
Requires:	mingw32-globus-libtool >= 1
Requires:	mingw32-globus-core >= 4
BuildRequires:	grid-packaging-tools
BuildRequires:	mingw32-globus-libtool >= 1
BuildRequires:	mingw32-globus-core >= 4
BuildRequires:	mingw32-filesystem
BuildRequires:	mingw32-gcc
BuildRequires:	mingw32-dlfcn

%description
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The %{name} package contains:
Common Library
Common Setup

%{?_mingw32_debug_package}

%prep
%setup -q -n %{_name}-%{version}
%setup -D -T -q -n %{_name}-%{version} -a 1
%patch0 -p1 -b .usr
%patch1 -p1 -b .segfault
%patch2 -p1 -b .noflavext
%patch3 -p1 -b .deps
%patch4 -p1 -b .typo
%patch5 -p1 -b .nofile
%patch6 -p1 -b .doxygen
%patch7 -p1 -b .extradist
%patch8 -p1 -b .ltdlmutex
%patch9 -p1 -b .mingw
%patch10 -p1 -b .pathmax
%patch11 -p1 -b .mfheader
%patch12 -p1 -b .doxygenbug
cd %{_name}_setup-%{setupversion}
%patch13 -p1 -b .setup
cd -

%build
export GLOBUS_LOCATION=%{_mingw32_prefix}

# Remove files that should be replaced during bootstrap
rm -f doxygen/Doxyfile*
rm -f doxygen/Makefile.am
rm -f pkgdata/Makefile.am
rm -f globus_automake*
rm -rf autom4te.cache

# Remove flavor tags
for f in `find . -name Makefile.am` ; do
  sed -e 's!^flavorinclude_HEADERS!include_HEADERS!' \
      -e 's!\(lib[a-zA-Z_]*\)_$(GLOBUS_FLAVOR_NAME)\.la!\1.la!g' \
      -e 's!^\(lib[a-zA-Z_]*\)___GLOBUS_FLAVOR_NAME__la_!\1_la_!' -i $f
done
sed -e "s!<With_Flavors!<With_Flavors ColocateLibraries=\"no\"!" \
  -i pkgdata/pkg_data_src.gpt.in

# This really should be done by configure - but it is not
sed -e '/^Sources=/a \
	globus_libtool_windows.c \\' \
    -e '/include_HEADERS =/a \
	globus_libtool_windows.h \\' -i library/Makefile.am

%{_mingw32_datadir}/globus/globus-bootstrap.sh

# Configure gets these wrong for mingw
export ac_cv_func_gethostbyname=yes
export lac_cv_lsocket=no
export lac_cv_lnsl=no

# External windows libraries
export EXTERNAL_LIBS="-liphlpapi -lws2_32"

export GLOBUS_VERSION=5.0.3
%_mingw32_configure --with-flavor=%{flavor}

make %{?_smp_mflags}

# setup package
cd %{_name}_setup-%{setupversion}

# Remove files that should be replaced during bootstrap
rm -f doxygen/Doxyfile*
rm -f doxygen/Makefile.am
rm -f pkgdata/Makefile.am
rm -f globus_automake*
rm -rf autom4te.cache

%{_mingw32_datadir}/globus/globus-bootstrap.sh

%_mingw32_configure --without-flavor \
		    --with-secure-tmpdir=%{_mingw32_localstatedir}/tmp

make %{?_smp_mflags}

cd -

%install
export GLOBUS_LOCATION=%{_mingw32_prefix}

rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# setup package
cd %{_name}_setup-%{setupversion}
make install DESTDIR=$RPM_BUILD_ROOT
cd -

# These scripts are intended to be sourced, not executed
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-args-parser-header
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/setup/setup-globus-common.pl
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-script-initializer
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-sh-tools.sh

# Register setup
perl -MGrid::GPT::Setup <<EOF
my \$metadata = new Grid::GPT::Setup(package_name => "%{_name}_setup",
				     globusdir => "$RPM_BUILD_ROOT%{_mingw32_prefix}");
\$metadata->finish();
EOF

GLOBUSPACKAGEDIR=$RPM_BUILD_ROOT%{_mingw32_datadir}/globus/packages

# Remove static libraries (.a files)
rm $RPM_BUILD_ROOT%{_mingw32_libdir}/libglobus_common.a
sed '/libglobus_common.a$/d' \
  -i $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist

# Generate pkg-config file from GPT metadata
mkdir -p $RPM_BUILD_ROOT%{_mingw32_libdir}/pkgconfig
%{_mingw32_datadir}/globus/mingw32-globus-gpt2pkg-config \
  pkgdata/pkg_data_%{flavor}_dev.gpt > \
  $RPM_BUILD_ROOT%{_mingw32_libdir}/pkgconfig/%{oname}.pc

# Move globus-makefile-header to devel package
grep globus-makefile-header $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist \
  >> $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist
sed /globus-makefile-header/d \
  -i $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist

# Don't use /usr/bin/env
sed 's!/usr/bin/env perl!/usr/bin/perl!' \
  -i $RPM_BUILD_ROOT%{_mingw32_bindir}/globus-makefile-header

# Install license file
mkdir -p $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}
install -m 644 -p GLOBUS_LICENSE \
  $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}

# Generate package filelists
cat $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_rtl.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/noflavor_data.filelist \
    $GLOBUSPACKAGEDIR/%{_name}_setup/noflavor_rtl.filelist \
    $GLOBUSPACKAGEDIR/%{_name}_setup/noflavor_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}_setup/noflavor_data.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist \
  | sed s!^!%{_mingw32_prefix}! > package.filelist

# Touch ghost files
touch $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/setup/globus-sh-tools-vars.sh
touch $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-sh-tools-vars.sh

%clean
rm -rf $RPM_BUILD_ROOT

%post
cd %{_mingw32_datadir}/globus/setup
./findshelltools > /dev/null
cp -p globus-sh-tools-vars.sh ..
rm -f config.log config.status

%files -f package.filelist
%defattr(-,root,root,-)
%dir %{_mingw32_datadir}/globus/packages/%{_name}
%dir %{_mingw32_datadir}/globus/packages/%{_name}_setup
%{_mingw32_datadir}/globus/packages/setup
%dir %{_mingw32_datadir}/globus/setup
%dir %{_mingw32_libdir}/perl
%dir %{_mingw32_libdir}/perl/Globus
%dir %{_mingw32_libdir}/perl/Globus/Core
%ghost %{_mingw32_datadir}/globus/setup/globus-sh-tools-vars.sh
%ghost %{_mingw32_datadir}/globus/globus-sh-tools-vars.sh
%dir %{_mingw32_includedir}/globus
%{_mingw32_libdir}/pkgconfig/%{oname}.pc
%{_mingw32_bindir}/libglobus_common-0.dll
%dir %{_mingw32_docdir}/%{name}-%{version}
%doc %{_mingw32_docdir}/%{name}-%{version}/GLOBUS_LICENSE

%changelog
* Wed Jun 22 2011 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.6-1
- Update to Globus Toolkit 5.0.3

* Sat Jul 17 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.5-1
- Update to Globus Toolkit 5.0.2

* Mon May 03 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.4-1
- Update to Globus Toolkit 5.0.1

* Wed Mar 10 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.2-2
- Add debug package

* Sun Mar 07 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.2-1
- Update to Globus Toolkit 5.0.0

* Wed May 06 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 10.2-1
- Autogenerated
